function varargout = Harris(varargin)
% HARRIS MATLAB code for Harris.fig
%      HARRIS, by itself, creates a new HARRIS or raises the existing
%      singleton*.
%
%      H = HARRIS returns the handle to a new HARRIS or the handle to
%      the existing singleton*.
%
%      HARRIS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in HARRIS.M with the given input arguments.
%
%      HARRIS('Property','Value',...) creates a new HARRIS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Harris_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Harris_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Harris

% Last Modified by GUIDE v2.5 27-Apr-2016 17:31:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Harris_OpeningFcn, ...
                   'gui_OutputFcn',  @Harris_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Harris is made visible.
function Harris_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Harris (see VARARGIN)

handles.paramsGen=varargin{1};
% Choose default command line output for Harris
handles.output = hObject;

% read in default parameter values
fid=fopen ('default.conf');
conf1=textscan(fid, '%s %n', 'CommentStyle' , '#', 'Delimiter', ':');
set(handles.edit_runs, 'String', num2str(conf1{1,2}(18)));
set(handles.edit_noElems, 'String', num2str(conf1{1,2}(19)));
set(handles.edit_density, 'String', num2str(conf1{1,2}(20)));
set(handles.edit_gain, 'String', num2str(conf1{1,2}(21)));
handles.alphadefault=conf1{1,2}(22);
if conf1{1,2}(23) < 0
    set (handles.edit_cap, 'Visible', 'off', 'String', [])
    set (handles.checkbox_capacity, 'ForegroundColor', [0 0 0], 'Value', 1)
else
    set(handles.edit_cap, 'Visible', 'on', 'String', num2str(conf1{1,2}(23)))
    set (handles.checkbox_capacity, 'ForegroundColor', [.7 .7 .7], 'Value', 0)
end
set(handles.edit_fraction, 'String', num2str(conf1{1,2}(24)));    
set(handles.popupmenu_simple, 'Value', conf1{1,2}(25));
set(handles.checkbox_activationPlots, 'Value', conf1{1,2}(26));
fclose(fid);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Harris wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Harris_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_savePath_Callback(hObject, eventdata, handles)
% hObject    handle to edit_savePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_savePath as text
%        str2double(get(hObject,'String')) returns contents of edit_savePath as a double


% --- Executes during object creation, after setting all properties.
function edit_savePath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_savePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_savePath.
function pushbutton_savePath_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_savePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[name, path] = uiputfile('*.txt','Save simulation results here');

if (path ~= 0)
    set(handles.edit_savePath, 'String', [path name]);
end

% --- Executes on button press in checkbox_activationPlots.
function checkbox_activationPlots_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_activationPlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_activationPlots


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% runs         The number of runs to perform
% noElems      The number of elements used to represent each single CS
% density      The connection density in percent/100
% gain         The buffer gain, i.e., the factor by which the activation
%               of elements in the buffer is multiplied.
% beta         The Rescorla-Wagner learning rule beta
% cap          The capacity of the attention buffer
% fraction     The overlap of CS elements in percent/100
% simple       Indicates whether to use the simplified learning equation or not.
% alphas     The salience of single CS


% alltrials    CS (compounds) presented on each trial in all phases
% eval         The CS (compounds) to be evaluated


paramsGen=handles.paramsGen;
if exist('paramsH', 'var')
    clear paramsH
end

paramsH.runs = str2num(get(handles.edit_runs, 'string'));
paramsH.noElems = str2num(get(handles.edit_noElems, 'string'));
paramsH.density = str2num(get(handles.edit_density, 'string'));
paramsH.gain= str2num(get(handles.edit_gain, 'string'));

if (get(handles.checkbox_capacity, 'Value')) == 1
    paramsH.cap= -20;
else
    paramsH.cap=str2double(get(handles.edit_cap, 'string'));
end
paramsH.fraction=str2double(get(handles.edit_fraction, 'string'));
paramsH.simple= get(handles.popupmenu_simple, 'value');
paramsH.alphas= str2num(get(handles.edit_alpha,  'string'));
paramsH.alphadefault=handles.alphadefault;
[pathstr, name]=fileparts(get(handles.edit_savePath,'String')); %parse filename and path 
paramsH.savePath={pathstr,name};
paramsH.activationPlots=get(handles.checkbox_activationPlots, 'value');


if ~isempty(paramsH.runs) & ~isempty(paramsH.noElems) & ~isempty(paramsH.density) ...
        & ~isempty(paramsH.gain)& ~isnan(paramsH.fraction)  & ~isnan(paramsH.cap)
    [res, paramsH]=trainH(paramsGen, paramsH);
else
    errordlg('Something is missing. Please check if you''ve entered all necessary parameters.')
end
%update alpha 
set(handles.edit_alpha, 'String', num2str(paramsH.alphas));
guidata(hObject, handles);


function edit_runs_Callback(hObject, eventdata, handles)
% hObject    handle to edit_runs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_runs as text
%        str2double(get(hObject,'String')) returns contents of edit_runs as a double


% --- Executes during object creation, after setting all properties.
function edit_runs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_runs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_noElems_Callback(hObject, eventdata, handles)
% hObject    handle to edit_noElems (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_noElems as text
%        str2double(get(hObject,'String')) returns contents of edit_noElems as a double


% --- Executes during object creation, after setting all properties.
function edit_noElems_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_noElems (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_density_Callback(hObject, eventdata, handles)
% hObject    handle to edit_density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_density as text
%        str2double(get(hObject,'String')) returns contents of edit_density as a double


% --- Executes during object creation, after setting all properties.
function edit_density_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_gain_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gain as text
%        str2double(get(hObject,'String')) returns contents of edit_gain as a double


% --- Executes during object creation, after setting all properties.
function edit_gain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_alpha_Callback(hObject, eventdata, handles)
% hObject    handle to edit_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_alpha as text
%        str2double(get(hObject,'String')) returns contents of edit_alpha as a double


% --- Executes during object creation, after setting all properties.
function edit_alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_capacity.
function checkbox_capacity_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_capacity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_capacity

if get(hObject, 'Value') == 1
    set(handles.edit_cap, 'Visible', 'off', 'string', [])
    set (hObject, 'ForegroundColor', [0 0 0])
elseif get(hObject, 'Value') == 0
    set(handles.edit_cap, 'Visible', 'on')
    set (hObject, 'ForegroundColor', [.7 .7 .7])
end


function edit_cap_Callback(hObject, eventdata, handles)
% hObject    handle to edit_cap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_cap as text
%        str2double(get(hObject,'String')) returns contents of edit_cap as a double


% --- Executes during object creation, after setting all properties.
function edit_cap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_cap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_fraction_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_fraction as text
%        str2double(get(hObject,'String')) returns contents of edit_fraction as a double


% --- Executes during object creation, after setting all properties.
function edit_fraction_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_simple.
function popupmenu_simple_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_simple (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_simple contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_simple


% --- Executes during object creation, after setting all properties.
function popupmenu_simple_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_simple (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
