function varargout = InElements(varargin)
% INELEMENTS MATLAB code for InElements.fig
%      INELEMENTS, by itself, creates a new INELEMENTS or raises the existing
%      singleton*.
%
%      H = INELEMENTS returns the handle to a new INELEMENTS or the handle to
%      the existing singleton*.
%
%      INELEMENTS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INELEMENTS.M with the given input arguments.
%
%      INELEMENTS('Property','Value',...) creates a new INELEMENTS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before InElements_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to InElements_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help InElements

% Last Modified by GUIDE v2.5 27-Apr-2016 17:11:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @InElements_OpeningFcn, ...
                   'gui_OutputFcn',  @InElements_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before InElements is made visible.
function InElements_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to InElements (see VARARGIN)

handles.paramsGen=varargin{1};

% Choose default command line output for InElements
handles.output = hObject;
% read in default parameter values
fid=fopen ('default.conf');
conf1=textscan(fid, '%s %n', 'CommentStyle' , '#', 'Delimiter', ':');


handles.alphadefault=conf1{1,2}(27);
set(handles.edit_normalisation, 'String',  conf1{1,2}(28));
set(handles.checkbox_weightsPlot, 'Value', conf1{1,2}(29));
set(handles.checkbox_activationPlots, 'Value', conf1{1,2}(30));
fclose(fid);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes InElements wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = InElements_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_saveMatrices_Callback(hObject, eventdata, handles)
% hObject    handle to edit_saveMatrices (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_saveMatrices as text
%        str2double(get(hObject,'String')) returns contents of edit_saveMatrices as a double


% --- Executes during object creation, after setting all properties.
function edit_saveMatrices_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_saveMatrices (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_saveMatrices.
function pushbutton_saveMatrices_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_saveMatrices (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[name, path] = uiputfile('..\simulations\*.txt','Save simulation results here');

if (path ~= 0)
    set(handles.edit_saveMatrices, 'String', [path name]);
end

% --- Executes on button press in checkbox_weightsPlot.
function checkbox_weightsPlot_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_weightsPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_weightsPlot


% --- Executes on button press in checkbox_activationPlots.
function checkbox_activationPlots_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_activationPlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_activationPlots


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
paramsGen = handles.paramsGen;

if exist('paramsINM', 'var')
    clear paramsINM
end


[pathstr, name]=fileparts(get(handles.edit_saveMatrices,'String')); %parse filename and path 
paramsINM.resultsPath ={pathstr,name};
paramsINM.startingWeights = get(handles.edit_startingWeights, 'string');
paramsINM.alpha = str2num(get(handles.edit_alpha, 'string'));
paramsINM.alphadefault=handles.alphadefault;
paramsINM.nn = str2num(get(handles.edit_normalisation, 'string'));
paramsINM.weightPlot = get(handles.checkbox_weightsPlot, 'value');
paramsINM.activationPlots=get(handles.checkbox_activationPlots, 'value');

if ~isempty(paramsINM.nn)
    paramsINM=trainINM(paramsGen, paramsINM);
else
    errordlg('Please specify amount of normalisation.')
end



%update alpha
set(handles.edit_alpha, 'String', num2str(paramsINM.alpha));
guidata(hObject, handles);


function edit_startingWeights_Callback(hObject, eventdata, handles)
% hObject    handle to edit_startingWeights (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_startingWeights as text
%        str2double(get(hObject,'String')) returns contents of edit_startingWeights as a double


% --- Executes during object creation, after setting all properties.
function edit_startingWeights_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_startingWeights (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_startingWeights.
function pushbutton_startingWeights_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_startingWeights (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[name, path] = uigetfile('..\simulations\*.txt', 'Load starting associative weights');

if (name ~= 0)
    set(handles.edit_startingWeights, 'String', [path, name]);
end


function edit_normalisation_Callback(hObject, eventdata, handles)
% hObject    handle to edit_normalisation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_normalisation as text
%        str2double(get(hObject,'String')) returns contents of edit_normalisation as a double


% --- Executes during object creation, after setting all properties.
function edit_normalisation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_normalisation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_alpha_Callback(hObject, eventdata, handles)
% hObject    handle to edit_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_alpha as text
%        str2double(get(hObject,'String')) returns contents of edit_alpha as a double


% --- Executes during object creation, after setting all properties.
function edit_alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
