function style=linestyle(noLines)
%creates noLines combinations of marker, color and linestyle 

% Copyright (C) 2006-2008  Anna Thorwart and Holger Schultheis
% with thanks to someone from the Math Forum Discussion Group

markerStyle={'o','*','s', 'x', 'v', 'o','*','s', 'x', 'v', 'o','*','s', 'x', 'v'};
lineColor = {'g', 'r', 'b', 'c', 'm', 'y', 'k','g', 'r', 'b', 'c', 'm', 'y', 'k'};
lineStyle = {'-','-.', '--', '-', '-.', '--', '-','-.', '--', '-', '-.', '--', '-','-.', '--', '-', '-.', '--'};

marker_idx= 1;
color_idx = 1;
style_idx = 1;

for i=1:noLines
    if color_idx > length(lineColor)
        color_idx = 1; % reset the color index.
    end
    if style_idx > length(lineStyle)
        style_idx = 1; % reset the style index.
    end
    if marker_idx > length(markerStyle)
        marker_idx = 1;
    end
    style {i}= [lineColor{color_idx}, lineStyle{style_idx}, markerStyle{marker_idx}];
    color_idx = color_idx + 1;
    style_idx = style_idx + 1;
    marker_idx = marker_idx + 1;
end